diff --git a/bindings/python/gpiod/Makefile.am b/bindings/python/gpiod/Makefile.am
index 49addcc..7e37b8d 100644
--- a/bindings/python/gpiod/Makefile.am
+++ b/bindings/python/gpiod/Makefile.am
@@ -1,4 +1,4 @@
-# SPDX-License-Identifier: LGPL-2.1-or-later
+# SPDX-License-Identifier: GPL-2.0-or-later
 # SPDX-FileCopyrightText: 2022 Bartosz Golaszewski <brgl@bgdev.pl>
 
 SUBDIRS = ext
diff --git a/bindings/python/gpiod/_internal.py b/bindings/python/gpiod/_internal.py
index c9b5d28..37f6661 100644
--- a/bindings/python/gpiod/_internal.py
+++ b/bindings/python/gpiod/_internal.py
@@ -1,4 +1,4 @@
-# SPDX-License-Identifier: GPL-2.0-or-later
+# SPDX-License-Identifier: LGPL-2.1-or-later
 # SPDX-FileCopyrightText: 2022 Bartosz Golaszewski <brgl@bgdev.pl>
 
 from datetime import timedelta
diff --git a/bindings/python/gpiod/ext/Makefile.am b/bindings/python/gpiod/ext/Makefile.am
index 9c81b17..3a8a0d1 100644
--- a/bindings/python/gpiod/ext/Makefile.am
+++ b/bindings/python/gpiod/ext/Makefile.am
@@ -1,4 +1,4 @@
-# SPDX-License-Identifier: LGPL-2.1-or-later
+# SPDX-License-Identifier: GPL-2.0-or-later
 # SPDX-FileCopyrightText: 2022 Bartosz Golaszewski <brgl@bgdev.pl>
 
 EXTRA_DIST = \
diff --git a/bindings/python/tests/Makefile.am b/bindings/python/tests/Makefile.am
index d6e3ea3..1809206 100644
--- a/bindings/python/tests/Makefile.am
+++ b/bindings/python/tests/Makefile.am
@@ -1,4 +1,4 @@
-# SPDX-License-Identifier: LGPL-2.1-or-later
+# SPDX-License-Identifier: GPL-2.0-or-later
 # SPDX-FileCopyrightText: 2022 Bartosz Golaszewski <brgl@bgdev.pl>
 
 SUBDIRS = gpiosim system
diff --git a/bindings/python/tests/gpiosim/Makefile.am b/bindings/python/tests/gpiosim/Makefile.am
index b403f3c..cc8c11a 100644
--- a/bindings/python/tests/gpiosim/Makefile.am
+++ b/bindings/python/tests/gpiosim/Makefile.am
@@ -1,4 +1,4 @@
-# SPDX-License-Identifier: LGPL-2.1-or-later
+# SPDX-License-Identifier: GPL-2.0-or-later
 # SPDX-FileCopyrightText: 2022 Bartosz Golaszewski <brgl@bgdev.pl>
 
 EXTRA_DIST = \
diff --git a/bindings/python/tests/gpiosim/__init__.py b/bindings/python/tests/gpiosim/__init__.py
index 64a1551..ddb59be 100644
--- a/bindings/python/tests/gpiosim/__init__.py
+++ b/bindings/python/tests/gpiosim/__init__.py
@@ -1,4 +1,4 @@
-# SPDX-License-Identifier: GPL-2.0-or-later
+# SPDX-License-Identifier: LGPL-2.1-or-later
 # SPDX-FileCopyrightText: 2022 Bartosz Golaszewski <brgl@bgdev.pl>
 
 from .chip import Chip
diff --git a/bindings/python/tests/helpers.py b/bindings/python/tests/helpers.py
index 2126901..ad272a1 100644
--- a/bindings/python/tests/helpers.py
+++ b/bindings/python/tests/helpers.py
@@ -1,4 +1,4 @@
-# SPDX-License-Identifier: GPL-2.0-or-later
+# SPDX-License-Identifier: LGPL-2.1-or-later
 # SPDX-FileCopyrightText: 2022 Bartosz Golaszewski <brgl@bgdev.pl>
 
 from __future__ import annotations
diff --git a/bindings/python/tests/system/Makefile.am b/bindings/python/tests/system/Makefile.am
index dbc8e64..3590be3 100644
--- a/bindings/python/tests/system/Makefile.am
+++ b/bindings/python/tests/system/Makefile.am
@@ -1,4 +1,4 @@
-# SPDX-License-Identifier: LGPL-2.1-or-later
+# SPDX-License-Identifier: GPL-2.0-or-later
 # SPDX-FileCopyrightText: 2022 Bartosz Golaszewski <brgl@bgdev.pl>
 
 EXTRA_DIST = \
diff --git a/bindings/python/tests/system/__init__.py b/bindings/python/tests/system/__init__.py
index cba9b92..99fde9c 100644
--- a/bindings/python/tests/system/__init__.py
+++ b/bindings/python/tests/system/__init__.py
@@ -1,4 +1,4 @@
-# SPDX-License-Identifier: GPL-2.0-or-later
+# SPDX-License-Identifier: LGPL-2.1-or-later
 # SPDX-FileCopyrightText: 2022 Bartosz Golaszewski <brgl@bgdev.pl>
 
 from ._ext import check_kernel_version, set_process_name
diff --git a/bindings/python/tests/tests_line.py b/bindings/python/tests/tests_line.py
index c96f6de..5bc742a 100644
--- a/bindings/python/tests/tests_line.py
+++ b/bindings/python/tests/tests_line.py
@@ -1,4 +1,4 @@
-# SPDX-License-Identifier: LGPL-2.1-or-later
+# SPDX-License-Identifier: GPL-2.0-or-later
 # SPDX-FileCopyrightText: 2024 Kent Gibson <warthog618@gmail.com>
 
 from unittest import TestCase
diff --git a/bindings/python/tests/tests_line_settings.py b/bindings/python/tests/tests_line_settings.py
index 66e01df..ad70921 100644
--- a/bindings/python/tests/tests_line_settings.py
+++ b/bindings/python/tests/tests_line_settings.py
@@ -1,4 +1,4 @@
-# SPDX-License-Identifier: LGPL-2.1-or-later
+# SPDX-License-Identifier: GPL-2.0-or-later
 # SPDX-FileCopyrightText: 2022 Bartosz Golaszewski <brgl@bgdev.pl>
 
 import datetime